����JFIF��������� Mr.X
  
  __  __    __   __  _____      _            _          _____ _          _ _ 
 |  \/  |   \ \ / / |  __ \    (_)          | |        / ____| |        | | |
 | \  / |_ __\ V /  | |__) | __ ___   ____ _| |_ ___  | (___ | |__   ___| | |
 | |\/| | '__|> <   |  ___/ '__| \ \ / / _` | __/ _ \  \___ \| '_ \ / _ \ | |
 | |  | | |_ / . \  | |   | |  | |\ V / (_| | ||  __/  ____) | | | |  __/ | |
 |_|  |_|_(_)_/ \_\ |_|   |_|  |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1
 if you need WebShell for Seo everyday contact me on Telegram
 Telegram Address : @jackleet
        
        
For_More_Tools: Telegram: @jackleet | Bulk Smtp support mail sender | Business Mail Collector | Mail Bouncer All Mail | Bulk Office Mail Validator | Html Letter private



Upload:

Command:

techbusinessbrai@216.73.217.116: ~ $
#!/bin/bash
KEXEC=/sbin/kexec

KDUMP_KERNELVER=""
KDUMP_KERNEL=""
KDUMP_COMMANDLINE=""
KEXEC_ARGS=""
KDUMP_CONFIG_FILE="/etc/kdump.conf"
KDUMP_LOG_PATH="/var/log"
MKDUMPRD="/sbin/mkdumprd -f"
MKFADUMPRD="/sbin/mkfadumprd"
DRACUT_MODULES_FILE="/usr/lib/dracut/modules.txt"
SAVE_PATH=/var/crash
SSH_KEY_LOCATION="/root/.ssh/kdump_id_rsa"
INITRD_CHECKSUM_LOCATION="/boot/.fadump_initrd_checksum"
DUMP_TARGET=""
DEFAULT_INITRD=""
DEFAULT_INITRD_BAK=""
KDUMP_INITRD=""
TARGET_INITRD=""
FADUMP_REGISTER_SYS_NODE="/sys/kernel/fadump_registered"
#kdump shall be the default dump mode
DEFAULT_DUMP_MODE="kdump"
image_time=0

standard_kexec_args="-d -p"

# Some default values in case /etc/sysconfig/kdump doesn't include
KDUMP_COMMANDLINE_REMOVE="hugepages hugepagesz slub_debug"

if [ -f /etc/sysconfig/kdump ]; then
	. /etc/sysconfig/kdump
fi

[[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
. $dracutbasedir/dracut-functions.sh
. /lib/kdump/kdump-lib.sh
. /lib/kdump/kdump-logger.sh

#initiate the kdump logger
dlog_init
if [ $? -ne 0 ]; then
	echo "failed to initiate the kdump logger."
	exit 1
fi

single_instance_lock()
{
	local rc timeout=5

	exec 9>/var/lock/kdump
	if [ $? -ne 0 ]; then
		derror "Create file lock failed"
		exit 1
	fi

	flock -n 9
	rc=$?

	while [ $rc -ne 0 ]; do
		dinfo "Another app is currently holding the kdump lock; waiting for it to exit..."
		flock -w $timeout 9
		rc=$?
	done
}

determine_dump_mode()
{
	# Check if firmware-assisted dump is enabled
	# if yes, set the dump mode as fadump
	if is_fadump_capable; then
		dinfo "Dump mode is fadump"
		DEFAULT_DUMP_MODE="fadump"
	fi
	ddebug "DEFAULT_DUMP_MODE=$DEFAULT_DUMP_MODE"
}

save_core()
{
	coredir="/var/crash/`date +"%Y-%m-%d-%H:%M"`"

	mkdir -p $coredir
	ddebug "cp --sparse=always /proc/vmcore $coredir/vmcore-incomplete"
	cp --sparse=always /proc/vmcore $coredir/vmcore-incomplete
	if [ $? == 0 ]; then
		mv $coredir/vmcore-incomplete $coredir/vmcore
		dinfo "saved a vmcore to $coredir"
	else
		derror "failed to save a vmcore to $coredir"
	fi

	# pass the dmesg to Abrt tool if exists, in order
	# to collect the kernel oops message.
	# https://fedorahosted.org/abrt/
	if [ -x /usr/bin/dumpoops ]; then
		ddebug "makedumpfile --dump-dmesg $coredir/vmcore $coredir/dmesg"
		makedumpfile --dump-dmesg $coredir/vmcore $coredir/dmesg >/dev/null 2>&1
		ddebug "dumpoops -d $coredir/dmesg"
		dumpoops -d $coredir/dmesg >/dev/null 2>&1
		if [ $? == 0 ]; then
			dinfo "kernel oops has been collected by abrt tool"
		fi
	fi
}

rebuild_fadump_initrd()
{
	if ! $MKFADUMPRD "$DEFAULT_INITRD_BAK" "$TARGET_INITRD" --kver "$KDUMP_KERNELVER"; then
		derror "mkfadumprd: failed to make fadump initrd"
		return 1
	fi

	sync -f "$TARGET_INITRD"
	return 0
}

check_earlykdump_is_enabled()
{
	grep -q -w "rd.earlykdump" /proc/cmdline
	return $?
}

rebuild_kdump_initrd()
{
	ddebug "rebuild kdump initrd: $MKDUMPRD $TARGET_INITRD $KDUMP_KERNELVER"
	$MKDUMPRD $TARGET_INITRD $KDUMP_KERNELVER
	if [ $? != 0 ]; then
		derror "mkdumprd: failed to make kdump initrd"
		return 1
	fi

	if check_earlykdump_is_enabled; then
		dwarn "Tips: If early kdump is enabled, also require rebuilding the system initramfs to make the changes take effect for early kdump."
	fi

	sync -f "$TARGET_INITRD"
	return 0
}

rebuild_initrd()
{
	if [[ ! -w $(dirname $TARGET_INITRD) ]];then
		derror "$(dirname $TARGET_INITRD) does not have write permission. Cannot rebuild $TARGET_INITRD"
		return 1
	fi

	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		rebuild_fadump_initrd
	else
		rebuild_kdump_initrd
	fi

	return $?
}

#$1: the files to be checked with IFS=' '
check_exist()
{
	for file in $1; do
		if [ ! -e "$file" ]; then
			derror "Error: $file not found."
			return 1
		fi
	done
}

#$1: the files to be checked with IFS=' '
check_executable()
{
	for file in $1; do
		if [ ! -x "$file" ]; then
			derror "Error: $file is not executable."
			return 1
		fi
	done
}

backup_default_initrd()
{
	ddebug "backup default initrd: $DEFAULT_INITRD"

	if [ ! -f "$DEFAULT_INITRD" ]; then
		return
	fi

	if [ ! -e $DEFAULT_INITRD_BAK ]; then
		dinfo "Backing up $DEFAULT_INITRD before rebuild."
		# save checksum to verify before restoring
		sha1sum $DEFAULT_INITRD > $INITRD_CHECKSUM_LOCATION
		cp $DEFAULT_INITRD $DEFAULT_INITRD_BAK
		if [ $? -ne 0 ]; then
			dwarn "WARNING: failed to backup $DEFAULT_INITRD."
			rm -f $DEFAULT_INITRD_BAK
		fi
	fi
}

restore_default_initrd()
{
	ddebug "restore default initrd: $DEFAULT_INITRD"

	if [ ! -f "$DEFAULT_INITRD" ]; then
		return
	fi

	# If a backup initrd exists, we must be switching back from
	# fadump to kdump. Restore the original default initrd.
	if [ -f $DEFAULT_INITRD_BAK ] && [ -f $INITRD_CHECKSUM_LOCATION ]; then
		# verify checksum before restoring
		backup_checksum=`sha1sum $DEFAULT_INITRD_BAK | awk '{ print $1 }'`
		default_checksum=`cat $INITRD_CHECKSUM_LOCATION | awk '{ print $1 }'`
		if [ "$default_checksum" != "$backup_checksum" ]; then
			dwarn "WARNING: checksum mismatch! Can't restore original initrd.."
		else
			rm -f $INITRD_CHECKSUM_LOCATION
			mv $DEFAULT_INITRD_BAK $DEFAULT_INITRD
			if [[ $? -eq 0 ]]; then
				derror "Restoring original initrd as fadump mode is disabled."
				sync -f "$DEFAULT_INITRD"
			fi
		fi
	fi
}

check_config()
{
	local -A _opt_rec
	while read -r config_opt config_val; do
		case "$config_opt" in
		dracut_args)
			if [[ $config_val == *--mount* ]]; then
				if [ $(echo $config_val | grep -o "\-\-mount" | wc -l) -ne 1 ]; then
					derror "Multiple mount targets specified in one \"dracut_args\"."
					return 1
				fi
				config_opt=_target
			fi
			;;
		raw)
			if [ -d "/proc/device-tree/ibm,opal/dump" ]; then
				derror "WARNING: Won't capture opalcore when 'raw' dump target is used."
				return 1
			fi
			config_opt=_target
			;;
		ext[234]|minix|btrfs|xfs|nfs|ssh)
			config_opt=_target
			;;
		sshkey|path|core_collector|kdump_post|kdump_pre|extra_bins|extra_modules|failure_action|default|final_action|force_rebuild|force_no_rebuild|fence_kdump_args|fence_kdump_nodes)
			;;
		net|options|link_delay|disk_timeout|debug_mem_level|blacklist)
			derror "Deprecated kdump config option: $config_opt. Refer to kdump.conf manpage for alternatives."
			return 1
			;;
		'')
			continue
			;;
		*)
			derror "Invalid kdump config option $config_opt"
			return 1
			;;
		esac

		if [[ -z "$config_val" ]]; then
			derror "Invalid kdump config value for option '$config_opt'"
			return 1
		fi

		if [ -n "${_opt_rec[$config_opt]}" ]; then
			if [ $config_opt == _target ]; then
				derror "More than one dump targets specified"
			else
				derror "Duplicated kdump config value of option $config_opt"
			fi
			return 1
		fi
		_opt_rec[$config_opt]="$config_val"
	done <<< "$(read_strip_comments $KDUMP_CONFIG_FILE)"

	check_failure_action_config || return 1
	check_final_action_config || return 1
	check_fence_kdump_config || return 1

	return 0
}

# get_pcs_cluster_modified_files <image timestamp>
# return list of modified file for fence_kdump modified in Pacemaker cluster
get_pcs_cluster_modified_files()
{
	local time_stamp
	local modified_files

	is_generic_fence_kdump && return 1
	is_pcs_fence_kdump || return 1

	time_stamp=`pcs cluster cib | xmllint --xpath 'string(/cib/@cib-last-written)' - | \
		xargs -0 date +%s --date`

	if [ -n $time_stamp -a $time_stamp -gt $image_time ]; then
		modified_files="cluster-cib"
	fi

	if [ -f $FENCE_KDUMP_CONFIG_FILE ]; then
		time_stamp=`stat -c "%Y" $FENCE_KDUMP_CONFIG_FILE`
		if [ "$time_stamp" -gt "$image_time" ]; then
			modified_files="$modified_files $FENCE_KDUMP_CONFIG_FILE"
		fi
	fi

	echo $modified_files
}

setup_initrd()
{
	prepare_kdump_bootinfo
	if [ $? -ne 0 ]; then
		derror "failed to prepare for kdump bootinfo."
		return 1
	fi

	DEFAULT_INITRD_BAK="$KDUMP_BOOTDIR/.$(basename $DEFAULT_INITRD).default"
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		TARGET_INITRD="$DEFAULT_INITRD"
		if [ ! -s "$TARGET_INITRD" ]; then
			derror "Error: No initrd found to rebuild!"
			return 1
		fi

		# backup initrd for reference before replacing it
		# with fadump aware initrd
		backup_default_initrd
	else
		TARGET_INITRD="$KDUMP_INITRD"

		# check if a backup of default initrd exists. If yes,
		# it signifies a switch from fadump mode. So, restore
		# the backed up default initrd.
		restore_default_initrd
	fi
}

check_files_modified()
{
	local modified_files=""

	#also rebuild when Pacemaker cluster conf is changed and fence kdump is enabled.
	modified_files=$(get_pcs_cluster_modified_files)

	EXTRA_BINS=`grep ^kdump_post $KDUMP_CONFIG_FILE | cut -d\  -f2`
	CHECK_FILES=`grep ^kdump_pre $KDUMP_CONFIG_FILE | cut -d\  -f2`
	HOOKS="/etc/kdump/post.d/ /etc/kdump/pre.d/"
	if [ -d /etc/kdump/post.d ]; then
		for file in /etc/kdump/post.d/*; do
			if [ -x "$file" ]; then
				POST_FILES="$POST_FILES $file"
			fi
		done
	fi
	if [ -d /etc/kdump/pre.d ]; then
		for file in /etc/kdump/pre.d/*; do
			if [ -x "$file" ]; then
				PRE_FILES="$PRE_FILES $file"
			fi
		done
	fi
	HOOKS="$HOOKS $POST_FILES $PRE_FILES"
	CORE_COLLECTOR=`grep ^core_collector $KDUMP_CONFIG_FILE | cut -d\  -f2`
	CORE_COLLECTOR=`type -P $CORE_COLLECTOR`
	# POST_FILES and PRE_FILES are already checked against executable, need not to check again.
	EXTRA_BINS="$EXTRA_BINS $CHECK_FILES"
	CHECK_FILES=`grep ^extra_bins $KDUMP_CONFIG_FILE | cut -d\  -f2-`
	EXTRA_BINS="$EXTRA_BINS $CHECK_FILES"
	files="$KDUMP_CONFIG_FILE $KDUMP_KERNEL $EXTRA_BINS $CORE_COLLECTOR"
	[[ -e /etc/fstab ]] && files="$files /etc/fstab"

	# Check for any updated extra module
	EXTRA_MODULES="$(grep ^extra_modules $KDUMP_CONFIG_FILE | sed 's/^extra_modules\s*//')"
	if [ -n "$EXTRA_MODULES" ]; then
		if [ -e /lib/modules/$KDUMP_KERNELVER/modules.dep ]; then
			files="$files /lib/modules/$KDUMP_KERNELVER/modules.dep"
		fi
		for _module in $EXTRA_MODULES; do
			_module_file="$(modinfo --set-version "$KDUMP_KERNELVER" --filename "$_module" 2>/dev/null)"
			if [[ $? -eq 0 ]]; then
				files="$files $_module_file"
				for _dep_modules in $(modinfo -F depends $_module | tr ',' ' '); do
				    files="$files $(modinfo --set-version "$KDUMP_KERNELVER" --filename $_dep_modules 2>/dev/null)"
				done
			else
				# If it's not a module nor builtin, give an error
				if ! ( modprobe --set-version "$KDUMP_KERNELVER" --dry-run "$_module" &>/dev/null ); then
					dwarn "Module $_module not found"
				fi
			fi
		done
	fi

	# HOOKS is mandatory and need to check the modification time
	files="$files $HOOKS"
	is_lvm2_thinp_dump_target && files="$files $LVM_CONF"
	check_exist "$files" && check_executable "$EXTRA_BINS"
	[ $? -ne 0 ] && return 2

	for file in $files; do
		if [ -e "$file" ]; then
			time_stamp=`stat -c "%Y" $file`
			if [ "$time_stamp" -gt "$image_time" ]; then
				modified_files="$modified_files $file"
			fi
			if [ -L "$file" ]; then
				file=$(readlink -m $file)
				time_stamp=`stat -c "%Y" $file`
				if [ "$time_stamp" -gt "$image_time" ]; then
					modified_files="$modified_files $file"
				fi
			fi
		else
			dwarn "$file doesn't exist"
		fi
	done

	if [ -n "$modified_files" ]; then
		dinfo "Detected change(s) in the following file(s): $modified_files"
		return 1
	fi

	return 0
}

check_drivers_modified()
{
	local _target _new_drivers _old_drivers _module_name _module_filename

	# If it's dump target is on block device, detect the block driver
	_target=$(get_block_dump_target)
	if [[ -n "$_target" ]]; then
		_record_block_drivers() {
			local _drivers
			_drivers=$(udevadm info -a "/dev/block/$1" | sed -n 's/\s*DRIVERS=="\(\S\+\)"/\1/p')
			for _driver in $_drivers; do
				if ! [[ " $_new_drivers " == *" $_driver "* ]]; then
					_new_drivers="$_new_drivers $_driver"
				fi
			done

			ddebug "MAJ:MIN=$1 drivers='$_drivers'"
		}
		check_block_and_slaves_all _record_block_drivers "$(get_maj_min "$_target")"
	fi

	# Include watchdog drivers if watchdog module is not omitted
	is_dracut_mod_omitted watchdog || is_dracut_mod_omitted watchdog-modules || _new_drivers+=" $(get_watchdog_drvs)"

	[ -z "$_new_drivers" ] && return 0
	if is_fadump_capable; then
		_old_drivers="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/fadump-kernel-modules.txt | tr '\n' ' ')"
	else
		_old_drivers="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/loaded-kernel-modules.txt | tr '\n' ' ')"
	fi

	ddebug "Modules required for kdump: '$_new_drivers'"
	ddebug "Modules included in old initramfs: '$_old_drivers'"
	for _driver in $_new_drivers; do
		# Skip deprecated/invalid driver name or built-in module
		_module_name=$(modinfo --set-version "$KDUMP_KERNELVER" -F name $_driver 2>/dev/null)
		_module_filename=$(modinfo --set-version "$KDUMP_KERNELVER" -n $_driver 2>/dev/null)
		if [ $? -ne 0 ] || [ -z "$_module_name" ] || [[ "$_module_filename" = *"(builtin)"* ]]; then
			continue
		fi
		if ! [[ " $_old_drivers " == *" $_module_name "* ]]; then
			dinfo "Detected change in block device driver, new loaded module: $_module_name"
			return 1
		fi
	done
}

check_fs_modified()
{
	local _old_dev _old_mntpoint _old_fstype
	local _new_dev _new_mntpoint _new_fstype
	local _target _dracut_args

	# No need to check in case of mount target specified via "dracut_args".
	if is_mount_in_dracut_args; then
		return 0
	fi

	# No need to check in case of raw target.
	# Currently we do not check also if ssh/nfs/thinp target is specified
	if is_ssh_dump_target || is_nfs_dump_target || is_raw_dump_target ||
	   is_lvm2_thinp_dump_target; then
		return 0
	fi

	_target=$(get_block_dump_target)
	_new_fstype=$(get_fs_type_from_target $_target)
	if [[ -z "$_target" ]] || [[ -z "$_new_fstype" ]];then
		derror "Dump target is invalid"
		return 2
	fi

	ddebug "_target=$_target _new_fstype=$_new_fstype"
	_new_dev=$(kdump_get_persistent_dev $_target)
	if [ -z "$_new_dev" ]; then
		perror "Get persistent device name failed"
		return 2
	fi

	_new_mntpoint="$(get_kdump_mntpoint_from_target $_target)"
	_dracut_args=$(lsinitrd $TARGET_INITRD -f usr/lib/dracut/build-parameter.txt)
	if [[ -z "$_dracut_args" ]];then
		dwarn "Warning: No dracut arguments found in initrd"
		return 0
	fi

	# if --mount argument present then match old and new target, mount
	# point and file system. If any of them mismatches then rebuild
	echo $_dracut_args | grep "\-\-mount" &> /dev/null
	if [[ $? -eq 0 ]];then
		set -- $(echo $_dracut_args | awk -F "--mount '" '{print $2}' | cut -d' ' -f1,2,3)
		_old_dev=$1
		_old_mntpoint=$2
		_old_fstype=$3
		[[ $_new_dev = $_old_dev && $_new_mntpoint = $_old_mntpoint && $_new_fstype = $_old_fstype ]] && return 0
	# otherwise rebuild if target device is not a root device
	else
		[[ "$_target" = "$(get_root_fs_device)" ]] && return 0
	fi

	dinfo "Detected change in File System"
	return 1
}

# returns 0 if system is not modified
# returns 1 if system is modified
# returns 2 if system modification is invalid
check_system_modified()
{
	local ret
	local CONF_ERROR=2
	local CONF_MODIFY=1
	local CONF_NO_MODIFY=0
	local conf_status=$CONF_NO_MODIFY

	[[ -f $TARGET_INITRD ]] || return 1

	for _func in check_files_modified check_fs_modified check_drivers_modified; do
		$_func
		ret=$?
		# return immediately if an error occurred.
		[[ $ret -eq "$CONF_ERROR" ]] && return "$ret"
		[[ $ret -eq "$CONF_MODIFY" ]] && { conf_status="$CONF_MODIFY"; }
	done

	return $conf_status
}

check_rebuild()
{
	local capture_capable_initrd="1"
	local _force_rebuild force_rebuild="0"
	local _force_no_rebuild force_no_rebuild="0"
	local ret system_modified="0"

	setup_initrd

	if [ $? -ne 0 ]; then
		return 1
	fi

	_force_no_rebuild=`grep ^force_no_rebuild $KDUMP_CONFIG_FILE 2>/dev/null`
	if [ $? -eq 0 ]; then
		force_no_rebuild=`echo $_force_no_rebuild | cut -d' '  -f2`
		if [ "$force_no_rebuild" != "0" ] && [ "$force_no_rebuild" != "1" ];then
			derror "Error: force_no_rebuild value is invalid"
			return 1
		fi
	fi

	_force_rebuild=`grep ^force_rebuild $KDUMP_CONFIG_FILE 2>/dev/null`
	if [ $? -eq 0 ]; then
		force_rebuild=`echo $_force_rebuild | cut -d' '  -f2`
		if [ "$force_rebuild" != "0" ] && [ "$force_rebuild" != "1" ];then
			derror "Error: force_rebuild value is invalid"
			return 1
		fi
	fi

	if [[ "$force_no_rebuild" == "1" && "$force_rebuild" == "1" ]]; then
		derror "Error: force_rebuild and force_no_rebuild are enabled simultaneously in kdump.conf"
		return 1
	fi

	# Will not rebuild kdump initrd
	if [ "$force_no_rebuild" == "1" ]; then
		return 0
	fi

	#check to see if dependent files has been modified
	#since last build of the image file
	if [ -f $TARGET_INITRD ]; then
		image_time=`stat -c "%Y" $TARGET_INITRD 2>/dev/null`

		#in case of fadump mode, check whether the default/target
		#initrd is already built with dump capture capability
		if [ "$DEFAULT_DUMP_MODE" == "fadump" ]; then
			capture_capable_initrd=$(lsinitrd -f $DRACUT_MODULES_FILE $TARGET_INITRD | grep -e ^kdumpbase$ -e ^zz-fadumpinit$ | wc -l)
		fi
	fi

	check_system_modified
	ret=$?
	if [ $ret -eq 2 ]; then
		return 1
	elif [ $ret -eq 1 ];then
		system_modified="1"
	fi

	if [ $image_time -eq 0 ]; then
		dinfo "No kdump initial ramdisk found."
	elif [ "$capture_capable_initrd" == "0" ]; then
		dinfo "Rebuild $TARGET_INITRD with dump capture support"
	elif [ "$force_rebuild" != "0" ]; then
		dinfo "Force rebuild $TARGET_INITRD"
	elif [ "$system_modified" != "0" ]; then
		:
	else
		return 0
	fi

	dinfo "Rebuilding $TARGET_INITRD"
	rebuild_initrd
	return $?
}

# On ppc64le LPARs, the keys trusted by firmware do not end up in
# .builtin_trusted_keys. So instead, add the key to the .ima keyring
function load_kdump_kernel_key()
{
	# this is only called inside is_secure_boot_enforced,
	# no need to retest

        # this is only required if DT /ibm,secure-boot is a file.
        # if it is a dir, we are on OpenPower and don't need this.
        if ! [ -f /proc/device-tree/ibm,secure-boot ]; then
                return
        fi

	keyctl padd asymmetric "" %:.ima < "/usr/share/doc/kernel-keys/$KDUMP_KERNELVER/kernel-signing-ppc.cer"
}

# Load the kdump kernel specified in /etc/sysconfig/kdump
# If none is specified, try to load a kdump kernel with the same version
# as the currently running kernel.
load_kdump()
{
	local ret

	KEXEC_ARGS=$(prepare_kexec_args "${KEXEC_ARGS}")
	KDUMP_COMMANDLINE=$(prepare_cmdline "${KDUMP_COMMANDLINE}" "${KDUMP_COMMANDLINE_REMOVE}" "${KDUMP_COMMANDLINE_APPEND}")

	ddebug "$KEXEC $KEXEC_ARGS $standard_kexec_args --command-line=$KDUMP_COMMANDLINE --initrd=$TARGET_INITRD $KDUMP_KERNEL"

	# The '12' represents an intermediate temporary file descriptor
	# to store the standard error file descriptor '2', and later
	# restore the error file descriptor with the file descriptor '12'
	# and release it.
	exec 12>&2
	exec 2>> $KDUMP_LOG_PATH/kdump.log
	chmod 600 $KDUMP_LOG_PATH/kdump.log
	PS4='+ $(date "+%Y-%m-%d %H:%M:%S") ${BASH_SOURCE}@${LINENO}: '
	set -x

	$KEXEC $KEXEC_ARGS $standard_kexec_args \
		--command-line="$KDUMP_COMMANDLINE" \
		--initrd=$TARGET_INITRD $KDUMP_KERNEL

	ret=$?
	set +x
	exec 2>&12 12>&-

	if [[ $ret == 0 ]]; then
		dinfo "kexec: loaded kdump kernel"
		return 0
	else
		derror "kexec: failed to load kdump kernel"
		return 1
	fi
}

check_ssh_config()
{
	while read config_opt config_val; do
		case "$config_opt" in
		sshkey)
			# remove inline comments after the end of a directive.
			if [ -f "$config_val" ]; then
				# canonicalize the path
				SSH_KEY_LOCATION=$(/usr/bin/readlink -m $config_val)
			else
				dwarn "WARNING: '$config_val' doesn't exist, using default value '$SSH_KEY_LOCATION'"
			fi
			;;
		path)
			SAVE_PATH=$config_val
			;;
		ssh)
			DUMP_TARGET=$config_val
			;;
		*)
			;;
		esac
	done <<< "$(read_strip_comments $KDUMP_CONFIG_FILE)"

	#make sure they've configured kdump.conf for ssh dumps
	local SSH_TARGET=`echo -n $DUMP_TARGET | sed -n '/.*@/p'`
	if [ -z "$SSH_TARGET" ]; then
		return 1
	fi
	return 0
}

# ipv6 host address may takes a long time to be ready.
# Instead of checking against ipv6 address, we just check the network reachable
# by the return val of 'ssh'
check_and_wait_network_ready()
{
	local start_time=$(date +%s)
	local warn_once=1
	local cur
	local diff
	local retval
	local errmsg

	while true; do
		errmsg=$(ssh -i $SSH_KEY_LOCATION -o BatchMode=yes $DUMP_TARGET mkdir -p $SAVE_PATH 2>&1)
		retval=$?

		# ssh exits with the exit status of the remote command or with 255 if an error occurred
		if [ $retval -eq 0 ]; then
			return 0
		elif [ $retval -ne 255 ]; then
			derror "Could not create $DUMP_TARGET:$SAVE_PATH, you should check the privilege on server side"
			return 1
		fi

		# if server removes the authorized_keys or, no /root/.ssh/kdump_id_rsa
		ddebug "$errmsg"
		echo $errmsg | grep -q "Permission denied\|No such file or directory\|Host key verification failed" &> /dev/null
		if [ $? -eq 0 ]; then
			derror "Could not create $DUMP_TARGET:$SAVE_PATH, you probably need to run \"kdumpctl propagate\""
			return 1
		fi

		if [ $warn_once -eq 1 ]; then
			dwarn "Network dump target is not usable, waiting for it to be ready..."
			warn_once=0
		fi

		cur=$(date +%s)
		let "diff = $cur - $start_time"
		# 60s time out
		if [ $diff -gt 180 ]; then
			break;
		fi
		sleep 1
	done

	dinfo "Could not create $DUMP_TARGET:$SAVE_PATH, ipaddr is not ready yet. You should check network connection"
	return 1
}

check_ssh_target()
{
	check_and_wait_network_ready
	if [ $? -ne 0 ]; then
		return 1
	fi
	return 0
}

propagate_ssh_key()
{
	check_ssh_config
	if [ $? -ne 0 ]; then
		derror "No ssh config specified in $KDUMP_CONFIG_FILE.  Can't propagate"
		exit 1
	fi

	local KEYFILE=$SSH_KEY_LOCATION
	local errmsg="Failed to propagate ssh key"

	#Check to see if we already created key, if not, create it.
	if [ -f $KEYFILE ]; then
		dinfo "Using existing keys..."
	else
		dinfo "Generating new ssh keys... "
		/usr/bin/ssh-keygen -t rsa -f $KEYFILE -N "" 2>&1 > /dev/null
		dinfo "done."
	fi

	#now find the target ssh user and server to contact.
	SSH_USER=`echo $DUMP_TARGET | cut -d\  -f2 | cut -d@ -f1`
	SSH_SERVER=`echo $DUMP_TARGET | sed -e's/\(.*@\)\(.*$\)/\2/'`

	#now send the found key to the found server
	ssh-copy-id -i $KEYFILE $SSH_USER@$SSH_SERVER
	RET=$?
	if [ $RET == 0 ]; then
		dinfo "$KEYFILE has been added to ~$SSH_USER/.ssh/authorized_keys on $SSH_SERVER"
		return 0
	else
		derror "$errmsg, $KEYFILE failed in transfer to $SSH_SERVER"
		exit 1
	fi
}

show_reserved_mem()
{
    local mem=$(get_reserved_mem_size)
    local mem_mb=$(expr $mem / 1024 / 1024)

    dinfo "Reserved "$mem_mb"MB memory for crash kernel"
}

check_current_fadump_status()
{
	# Check if firmware-assisted dump has been registered.
	rc=`cat $FADUMP_REGISTER_SYS_NODE`
	[ $rc -eq 1 ] && return 0
	return 1
}

check_current_status()
{
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		check_current_fadump_status
	else
		check_current_kdump_status
	fi

	return $?
}

save_raw()
{
	local kdump_dir
	local raw_target

	raw_target=$(awk '$1 ~ /^raw$/ { print $2; }' $KDUMP_CONFIG_FILE)
	[ -z "$raw_target" ] && return 0
	[ -b "$raw_target" ] || {
		derror "raw partition $raw_target not found"
		return 1
	}
	kdump_dir=`grep ^path $KDUMP_CONFIG_FILE | cut -d' '  -f2-`
	if [ -z "${kdump_dir}" ]; then
		coredir="/var/crash/`date +"%Y-%m-%d-%H:%M"`"
	else
		coredir="${kdump_dir}/`date +"%Y-%m-%d-%H:%M"`"
	fi

	mkdir -p "$coredir"
	[ -d "$coredir" ] || {
		derror "failed to create $coredir"
		return 1
	}
	if makedumpfile -R $coredir/vmcore <$raw_target >/dev/null 2>&1; then
		# dump found
		dinfo "Dump saved to $coredir/vmcore"
		# wipe makedumpfile header
		dd if=/dev/zero of=$raw_target bs=1b count=1 2>/dev/null
	else
		rm -rf "$coredir"
	fi

	return 0
}

local_fs_dump_target()
{
	local _target

	_target=$(egrep "^ext[234]|^xfs|^btrfs|^minix" /etc/kdump.conf)
	if [ $? -eq 0 ]; then
		echo $_target|awk '{print $2}'
	fi
}

path_to_be_relabeled()
{
	local _path _target _mnt="/" _rmnt

	if is_user_configured_dump_target; then
		if is_mount_in_dracut_args; then
		    return;
		fi

		_target=$(local_fs_dump_target)
		if [[ -n "$_target" ]]; then
			_mnt=$(get_mntpoint_from_target $_target)
			if ! is_mounted "$_mnt"; then
				return
			fi
		else
			return
		fi
	fi

	_path=$(get_save_path)
	# if $_path is masked by other mount, we will not relabel it.
	_rmnt=$(df $_mnt/$_path 2>/dev/null | tail -1 | awk '{ print $NF }')
	if [ "$_rmnt" == "$_mnt" ]; then
		echo $_mnt/$_path
	fi
}

selinux_relabel()
{
	local _path _i _attr

	_path=$(path_to_be_relabeled)
	if [ -z "$_path" ] || ! [ -d "$_path" ] ; then
		return
	fi

	while IFS= read -r -d '' _i; do
		_attr=$(getfattr -m "security.selinux" "$_i" 2>/dev/null)
		if [ -z "$_attr" ]; then
			restorecon "$_i";
		fi
	done < <(find "$_path" -print0)
}

check_fence_kdump_config()
{
	local hostname=`hostname`
	local ipaddrs=`hostname -I`
	local nodes=$(get_option_value "fence_kdump_nodes")

	for node in $nodes; do
		if [ "$node" = "$hostname" ]; then
			derror "Option fence_kdump_nodes cannot contain $hostname"
			return 1
		fi
		# node can be ipaddr
		echo "$ipaddrs " | grep "$node " > /dev/null
		if [ $? -eq 0 ]; then
			derror "Option fence_kdump_nodes cannot contain $node"
			return 1
		fi
	done

	return 0
}

check_dump_feasibility()
{
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		return 0
	fi

	check_kdump_feasibility
	return $?
}

start_fadump()
{
	echo 1 > $FADUMP_REGISTER_SYS_NODE
	if ! check_current_fadump_status; then
		derror "fadump: failed to register"
		return 1
	fi

	dinfo "fadump: registered successfully"
	return 0
}

start_dump()
{
	# On secure boot enabled Power systems, load kernel signing key on .ima for signature
	# verification using kexec file based syscall.
	if [[ "$(uname -m)" == ppc64le ]] && is_secure_boot_enforced; then
		load_kdump_kernel_key
	fi

	if [[ $DEFAULT_DUMP_MODE == "fadump" ]]; then
		start_fadump
	else
		load_kdump
	fi

	return $?
}

check_failure_action_config()
{
	local default_option
	local failure_action
	local option="failure_action"

	default_option=$(awk '$1 ~ /^default$/ {print $2;}' $KDUMP_CONFIG_FILE)
	failure_action=$(awk '$1 ~ /^failure_action$/ {print $2;}' $KDUMP_CONFIG_FILE)

	if [ -z "$failure_action" -a -z "$default_option" ]; then
		return 0
	elif [ -n "$failure_action" -a -n "$default_option" ]; then
		derror "Cannot specify 'failure_action' and 'default' option together"
		return 1
	fi

	if [ -n "$default_option" ]; then
		option="default"
		failure_action="$default_option"
	fi

	case "$failure_action" in
	  reboot|halt|poweroff|shell|dump_to_rootfs)
		return 0
	  ;;
	  *)
		dinfo $"Usage kdump.conf: $option {reboot|halt|poweroff|shell|dump_to_rootfs}"
		return 1
	esac
}

check_final_action_config()
{
	local final_action

	final_action=$(awk '$1 ~ /^final_action$/ {print $2;}' $KDUMP_CONFIG_FILE)
	if [ -z "$final_action" ]; then
		return 0
	else
		case "$final_action" in
		  reboot|halt|poweroff)
			return 0
		  ;;
		  *)
			dinfo $"Usage kdump.conf: final_action {reboot|halt|poweroff}"
			return 1
		esac
	fi
}

start()
{
	check_dump_feasibility
	if [ $? -ne 0 ]; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	check_config
	if [ $? -ne 0 ]; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	if sestatus 2>/dev/null | grep -q "SELinux status.*enabled"; then
		selinux_relabel
	fi

	save_raw
	if [ $? -ne 0 ]; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	check_current_status
	if [ $? == 0 ]; then
		dwarn "Kdump already running: [WARNING]"
		return 0
	fi

	if check_ssh_config; then
		if ! check_ssh_target; then
			derror "Starting kdump: [FAILED]"
			return 1
		fi
	fi

	check_rebuild
	if [ $? != 0 ]; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	start_dump
	if [ $? != 0 ]; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	dinfo "Starting kdump: [OK]"
}

reload()
{
	check_current_status
	if [ $? -ne 0 ]; then
		dwarn "Kdump was not running: [WARNING]"
	fi

	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		reload_fadump
		return $?
	else
		stop_kdump
	fi

	if [ $? -ne 0 ]; then
		derror "Stopping kdump: [FAILED]"
		return 1
	fi

	dinfo "Stopping kdump: [OK]"

	setup_initrd
	if [ $? -ne 0 ]; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	start_dump
	if [ $? -ne 0 ]; then
		derror "Starting kdump: [FAILED]"
		return 1
	fi

	dinfo "Starting kdump: [OK]"
}

stop_fadump()
{
	echo 0 > $FADUMP_REGISTER_SYS_NODE
	if check_current_fadump_status; then
		derror "fadump: failed to unregister"
		return 1
	fi

	dinfo "fadump: unregistered successfully"
	return 0
}

stop_kdump()
{
	if is_secure_boot_enforced; then
		$KEXEC -s -p -u
	else
		$KEXEC -p -u
	fi

	if [ $? != 0 ]; then
		derror "kexec: failed to unload kdump kernel"
		return 1
	fi

	dinfo "kexec: unloaded kdump kernel"
	return 0
}

reload_fadump()
{
	echo 1 > $FADUMP_REGISTER_SYS_NODE
	if [ $? == 0 ]; then
		dinfo "fadump: re-registered successfully"
		return 0
	else
		# FADump could fail on older kernel where re-register
		# support is not enabled. Try stop/start from userspace
		# to handle such scenario.
		stop_fadump
		if [ $? == 0 ]; then
			start_fadump
			return $?
		fi
	fi

	return 1
}

stop()
{
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		stop_fadump
	else
		stop_kdump
	fi

	if [ $? != 0 ]; then
		derror "Stopping kdump: [FAILED]"
		return 1
	fi

	dinfo "Stopping kdump: [OK]"
	return 0
}

rebuild() {
	check_config
	if [ $? -ne 0 ]; then
		return 1
	fi

	if check_ssh_config; then
		if ! check_ssh_target; then
			return 1
		fi
	fi

	setup_initrd
	if [ $? -ne 0 ]; then
		return 1
	fi

	dinfo "Rebuilding $TARGET_INITRD"
	rebuild_initrd
	return $?
}

do_estimate() {
	local kdump_mods
	local -A large_mods
	local baseline
	local kernel_size mod_size initrd_size baseline_size runtime_size reserved_size estimated_size recommended_size
	local size_mb=$(( 1024 * 1024 ))

	setup_initrd
	if [ ! -f "$TARGET_INITRD" ]; then
		derror "kdumpctl estimate: kdump initramfs is not built yet."
		exit 1
	fi

	kdump_mods="$(lsinitrd "$TARGET_INITRD" -f /usr/lib/dracut/loaded-kernel-modules.txt | tr '\n' ' ')"
	baseline=$(kdump_get_arch_recommend_size)
	if [[ "${baseline: -1}" == "M" ]]; then
		baseline=${baseline%M}
	elif [[ "${baseline: -1}" == "G" ]]; then
		baseline=$(( ${baseline%G} * 1024 ))
	elif [[ "${baseline: -1}" == "T" ]]; then
		baseline=$(( ${baseline%Y} * 1048576 ))
	fi

	# The default value when using crashkernel=auto
	baseline_size=$((baseline * size_mb))
	# Current reserved crashkernel size
	reserved_size=$(get_reserved_mem_size)
	# A pre-estimated value for userspace usage and kernel
	# runtime allocation, 64M should good for most cases
	runtime_size=$((64 * size_mb))
	# Kernel image size
	kernel_size=$(get_kernel_size "$KDUMP_KERNEL")
	# Kdump initramfs size
	initrd_size=$(du -b "$TARGET_INITRD" | awk '{print $1}')
	# Kernel modules static size after loaded
	mod_size=0
	while read -r _name _size _; do
		if [[ ! " $kdump_mods " == *" $_name "* ]]; then
			continue
		fi
		mod_size=$((mod_size + _size))

		# Mark module with static size larger than 2M as large module
		if [[ $((_size / size_mb)) -ge 1 ]]; then
			large_mods[$_name]=$_size
		fi
	done <<< "$(< /proc/modules)"

	# Extra memory usage required for LUKS2 decryption
	crypt_size=0
	for _dev in $(get_all_kdump_crypt_dev); do
		_crypt_info=$(cryptsetup luksDump "/dev/block/$_dev")
		[[ $(echo "$_crypt_info" | sed -n "s/^Version:\s*\(.*\)/\1/p" ) == "2" ]] || continue
		for _mem in $(echo "$_crypt_info" | sed -n "s/\sMemory:\s*\(.*\)/\1/p" | sort -n ); do
			crypt_size=$((crypt_size + _mem * 1024))
			break
		done
	done
	[[ $crypt_size -ne 0 ]] && echo -e "Encrypted kdump target requires extra memory, assuming using the keyslot with minimun memory requirement\n"

	estimated_size=$((kernel_size + mod_size + initrd_size + runtime_size + crypt_size))
	if [[ $baseline_size -gt $estimated_size ]]; then
		recommended_size=$baseline_size
	else
		recommended_size=$estimated_size
	fi

	echo "Reserved crashkernel:    $((reserved_size / size_mb))M"
	echo "Recommended crashkernel: $((recommended_size / size_mb))M"
	echo
	echo "Kernel image size:   $((kernel_size / size_mb))M"
	echo "Kernel modules size: $((mod_size / size_mb))M"
	echo "Initramfs size:      $((initrd_size / size_mb))M"
	echo "Runtime reservation: $((runtime_size / size_mb))M"
	[[ $crypt_size -ne 0 ]] && \
	echo "LUKS required size:  $((crypt_size / size_mb))M"
	echo -n "Large modules:"
	if [[ "${#large_mods[@]}" -eq 0 ]]; then
		echo " <none>"
	else
		echo ""
		for _mod in "${!large_mods[@]}"; do
			echo "    $_mod: ${large_mods[$_mod]}"
		done
	fi

	if [[ $reserved_size -lt $recommended_size ]]; then
		echo "WARNING: Current crashkernel size is lower than recommended size $((recommended_size / size_mb))M."
	fi
}

if [ ! -f "$KDUMP_CONFIG_FILE" ]; then
	derror "Error: No kdump config file found!"
	exit 1
fi

main ()
{
	# Determine if the dump mode is kdump or fadump
	determine_dump_mode

	case "$1" in
	  start)
		if [ -s /proc/vmcore ]; then
			save_core
			reboot
		else
			start
		fi
		;;
	  stop)
		stop
		;;
	  status)
		EXIT_CODE=0
		check_current_status
		case "$?" in
		  0)
			dinfo "Kdump is operational"
			EXIT_CODE=0
			;;
		  1)
			dinfo "Kdump is not operational"
			EXIT_CODE=3
			;;
		esac
		exit $EXIT_CODE
		;;
	  reload)
		reload
		;;
	  restart)
		stop
		start
		;;
	  rebuild)
		rebuild
		;;
	  condrestart)
		;;
	  propagate)
		propagate_ssh_key
		;;
	  showmem)
		show_reserved_mem
		;;
	  estimate)
		do_estimate
		;;
	  *)
		dinfo $"Usage: $0 {estimate|start|stop|status|restart|reload|rebuild|propagate|showmem}"
		exit 1
	esac
}

# Other kdumpctl instances will block in queue, until this one exits
single_instance_lock

# To avoid fd 9 leaking, we invoke a subshell, close fd 9 and call main.
# So that fd isn't leaking when main is invoking a subshell.
(exec 9<&-; main $1)

exit $?

Filemanager

Name Type Size Permission Actions
2to3 File 106 B 0755
2to3-3.6 File 106 B 0755
GET File 15.84 KB 0755
HEAD File 15.84 KB 0755
Mail File 408.89 KB 0755
POST File 15.84 KB 0755
[ File 53.6 KB 0755
ab File 72.63 KB 0755
aclocal File 35.62 KB 0755
aclocal-1.16 File 35.62 KB 0755
acyclic File 12.41 KB 0755
addr2line File 33.42 KB 0755
alias File 29 B 0755
animate File 11.84 KB 0755
apropos File 54.04 KB 0755
ar File 61.96 KB 0755
arch File 37.34 KB 0755
aria_chk File 5.38 MB 0755
aria_dump_log File 5.18 MB 0755
aria_ftdump File 5.19 MB 0755
aria_pack File 5.22 MB 0755
aria_read_log File 5.33 MB 0755
arpaname File 11.82 KB 0755
as File 889.91 KB 0755
aspell File 159.5 KB 0755
at File 57.33 KB 0755
atop File 284.66 KB 0755
atopconvert File 24.66 KB 0755
atopd File 922 B 0755
atopsar File 284.66 KB 0755
atq File 57.33 KB 0755
atrm File 57.33 KB 0755
aulast File 20.58 KB 0755
aulastlog File 12.44 KB 0755
ausyscall File 12.27 KB 0755
authselect File 41.13 KB 0755
autoconf File 14.42 KB 0755
autoheader File 8.33 KB 0755
autom4te File 31.43 KB 0755
automake File 251.9 KB 0755
automake-1.16 File 251.9 KB 0755
autopoint File 25.95 KB 0755
autoreconf File 20.57 KB 0755
autoscan File 16.72 KB 0755
autoupdate File 33.08 KB 0755
auvirt File 32.73 KB 0755
awk File 669.77 KB 0755
b2sum File 57.69 KB 0755
base32 File 41.47 KB 0755
base64 File 41.48 KB 0755
basename File 37.41 KB 0755
bash File 1.1 MB 0755
bashbug File 7.18 KB 0755
bashbug-64 File 7.18 KB 0755
batch File 137 B 0755
bc File 94.98 KB 0755
bcomps File 20.62 KB 0755
bdftopcf File 45.4 KB 0755
bg File 26 B 0755
bind9-config File 3.33 KB 0755
bison File 437.72 KB 0755
bond2team File 22.74 KB 0755
bootctl File 45.15 KB 0755
brotli File 739.2 KB 0755
bunzip2 File 36.86 KB 0755
busctl File 77.27 KB 0755
bwrap File 69.63 KB 0755
bzcat File 36.86 KB 0755
bzcmp File 2.08 KB 0755
bzdiff File 2.08 KB 0755
bzegrep File 1.64 KB 0755
bzfgrep File 1.64 KB 0755
bzgrep File 1.64 KB 0755
bzip2 File 36.86 KB 0755
bzip2recover File 16.44 KB 0755
bzless File 1.23 KB 0755
bzmore File 1.23 KB 0755
c++ File 1.21 MB 0755
c++filt File 28.89 KB 0755
c89 File 224 B 0755
c99 File 215 B 0755
ca-legacy File 1.61 KB 0755
cairo-sphinx File 69.71 KB 0755
cal File 65.98 KB 0755
cancel File 15.87 KB 0755
cancel.cups File 15.87 KB 0755
captoinfo File 85.31 KB 0755
cat File 37.46 KB 0755
catchsegv File 3.21 KB 0755
catman File 41.45 KB 0755
cc File 1.21 MB 0755
ccomps File 24.72 KB 0755
cd File 26 B 0755
centrino-decode File 11.27 KB 0755
certutil File 199.15 KB 0755
chacl File 16.36 KB 0755
chage File 77.68 KB 4755
chattr File 16.41 KB 0755
chcon File 70.34 KB 0755
chfn File 32.9 KB 4711
chgrp File 66.29 KB 0755
chmem File 45.47 KB 0755
chmod File 62.2 KB 0755
chown File 70.29 KB 0755
chrt File 37.19 KB 0755
chsh File 24.72 KB 0711
chvt File 12.53 KB 0755
cifsiostat File 41.35 KB 0755
circo File 12.26 KB 0755
cksum File 37.39 KB 0755
cl-linksafe-apply-group File 554 B 0755
cl-linksafe-reconfigure File 4.83 KB 0755
clear File 12.54 KB 0755
cluster File 518.33 KB 0755
cmp File 103.76 KB 0755
cmsutil File 122.46 KB 0755
col File 29.01 KB 0755
colcrt File 16.48 KB 0755
colrm File 24.88 KB 0755
column File 49.47 KB 0755
comm File 41.56 KB 0755
command File 31 B 0755
compare File 11.85 KB 0755
compile_et File 1.31 KB 0755
composite File 11.84 KB 0755
config_data File 6.97 KB 0755
conjure File 11.84 KB 0755
convert File 11.84 KB 0755
coredumpctl File 44.91 KB 0755
corelist File 14.64 KB 0755
cp File 147.98 KB 0755
cpan File 8.17 KB 0755
cpan-mirrors File 4.19 KB 0755
cpapi1 File 3.33 MB 0755
cpapi2 File 3.33 MB 0755
cpapi3 File 3.33 MB 0755
cpio File 159.8 KB 0755
cpp File 1.21 MB 0755
cpupower File 66.91 KB 0755
crb File 2.58 KB 0744
crc32 File 1.02 KB 0755
crlutil File 134.95 KB 0755
cronnext File 49.8 KB 0755
crontab File 61.67 KB 4755
csplit File 53.68 KB 0755
csslint-0.6 File 24.56 KB 0755
curl File 230.08 KB 0755
cut File 49.52 KB 0755
cvtsudoers File 284.21 KB 0755
cxpm File 29.11 KB 0755
date File 105.96 KB 0755
db_archive File 12.45 KB 0755
db_checkpoint File 16.48 KB 0755
db_deadlock File 16.48 KB 0755
db_dump File 16.51 KB 0755
db_dump185 File 69.55 KB 0755
db_hotbackup File 20.49 KB 0755
db_load File 28.61 KB 0755
db_log_verify File 16.52 KB 0755
db_printlog File 33.4 KB 0755
db_recover File 16.51 KB 0755
db_replicate File 16.49 KB 0755
db_stat File 16.48 KB 0755
db_tuner File 24.55 KB 0755
db_upgrade File 12.45 KB 0755
db_verify File 16.46 KB 0755
dbilogstrip File 1.35 KB 0755
dbiprof File 6.06 KB 0755
dbus-binding-tool File 110.43 KB 0755
dbus-cleanup-sockets File 16.39 KB 0755
dbus-daemon File 239.7 KB 0755
dbus-monitor File 28.58 KB 0755
dbus-run-session File 15.88 KB 0755
dbus-send File 28.54 KB 0755
dbus-test-tool File 24.6 KB 0755
dbus-update-activation-environment File 16.41 KB 0755
dbus-uuidgen File 12.38 KB 0755
dbxtool File 28.73 KB 0755
dc File 53.02 KB 0755
dd File 77.97 KB 0755
deallocvt File 12.54 KB 0755
debuginfo-install File 3.62 KB 0755
debuginfod-find File 16.47 KB 0755
delv File 42.46 KB 0755
df File 91.09 KB 0755
dfu-tool File 121.79 KB 0755
diff File 268.01 KB 0755
diff3 File 128.6 KB 0755
diffimg File 12.27 KB 0755
dig File 162.18 KB 0755
dijkstra File 16.71 KB 0755
dir File 139.9 KB 0755
dircolors File 49.55 KB 0755
dirmngr File 579.89 KB 0755
dirmngr-client File 120.12 KB 0755
dirname File 33.36 KB 0755
display File 11.84 KB 0755
dltest File 11.87 KB 0755
dmesg File 77.88 KB 0755
dnf File 2.05 KB 0755
dnf-3 File 2.05 KB 0755
dnsdomainname File 21.16 KB 0755
dnstap-read File 20.43 KB 0755
domainname File 21.16 KB 0755
dot File 12.26 KB 0755
dot2gxl File 41.3 KB 0755
dotty File 2.04 KB 0755
doveadm File 946.91 KB 0755
doveconf File 383.93 KB 0755
dovecot-sysreport File 5.81 KB 0755
dpkg File 316.17 KB 0755
dpkg-deb File 165.5 KB 0755
dpkg-divert File 157.75 KB 0755
dpkg-maintscript-helper File 20.67 KB 0755
dpkg-query File 165.84 KB 0755
dpkg-realpath File 4.05 KB 0755
dpkg-split File 132.39 KB 0755
dpkg-statoverride File 66.41 KB 0755
dpkg-trigger File 87.66 KB 0755
dracut File 67.56 KB 0755
dtrace File 17.39 KB 0755
du File 107 KB 0755
dumpkeys File 169.88 KB 0755
dumpsexp File 16.43 KB 0755
dwp File 2.13 MB 0755
dwz File 167.64 KB 0755
ea-php73 File 5.32 MB 0755
ea-php73-pear File 383 B 0755
ea-php73-pecl File 299 B 0755
ea-php74 File 6.09 MB 0755
ea-php74-pear File 383 B 0755
ea-php74-pecl File 299 B 0755
ea-php80 File 7.61 MB 0755
ea-php80-pear File 383 B 0755
ea-php80-pecl File 299 B 0755
ea-php81 File 7.72 MB 0755
ea-php81-pear File 383 B 0755
ea-php81-pecl File 299 B 0755
ea-php82 File 7.77 MB 0755
ea-php82-pear File 383 B 0755
ea-php82-pecl File 299 B 0755
ea-php83 File 7.8 MB 0755
ea-php83-pear File 383 B 0755
ea-php83-pecl File 299 B 0755
ea-wappspector File 100 B 0755
easy_install-2 File 234 B 0755
easy_install-2.7 File 234 B 0755
easy_install-3 File 246 B 0755
easy_install-3.6 File 246 B 0755
echo File 37.35 KB 0755
ed File 57.28 KB 0755
edgepaint File 420.79 KB 0755
egrep File 28 B 0755
eject File 57.78 KB 0755
elfedit File 33.28 KB 0755
enc2xs File 40.97 KB 0755
encguess File 2.91 KB 0755
env File 41.35 KB 0755
envml File 4.1 KB 0755
envsubst File 48.99 KB 0755
eps2eps File 639 B 0755
eqn File 232.16 KB 0755
event_rpcgen.py File 54.26 KB 0755
evmctl File 62.54 KB 0755
ex File 1.13 MB 0755
expand File 41.59 KB 0755
expr File 49.57 KB 0755
factor File 85.97 KB 0755
fallocate File 28.96 KB 0755
false File 33.32 KB 0755
fc File 26 B 0755
fc-cache File 132 B 0755
fc-cache-64 File 20.35 KB 0755
fc-cat File 16.35 KB 0755
fc-conflist File 12.25 KB 0755
fc-list File 12.25 KB 0755
fc-match File 16.26 KB 0755
fc-pattern File 12.26 KB 0755
fc-query File 12.24 KB 0755
fc-scan File 12.26 KB 0755
fc-validate File 16.26 KB 0755
fdp File 12.26 KB 0755
fg File 26 B 0755
fgconsole File 12.55 KB 0755
fgrep File 28 B 0755
filan File 94.72 KB 0755
file File 24.69 KB 0755
fincore File 33.04 KB 0755
find File 223.27 KB 0755
find-repos-of-install File 3.62 KB 0755
findmnt File 70.61 KB 0755
fips-finish-install File 1.29 KB 0755
fips-mode-setup File 3.91 KB 0755
firewall-cmd File 139.6 KB 0755
firewall-offline-cmd File 120.73 KB 0755
flex File 428.45 KB 0755
flex++ File 428.45 KB 0755
flock File 33.2 KB 0755
fmt File 45.49 KB 0755
fold File 41.42 KB 0755
fonttosfnt File 41.18 KB 0755
free File 20.79 KB 0755
freetype-config File 4.31 KB 0755
fribidi File 21.14 KB 0755
ftp File 101.2 KB 0755
funzip File 36.63 KB 0755
fwupdagent File 226.92 KB 0755
fwupdate File 101.66 KB 0755
fwupdmgr File 226.92 KB 0755
fwupdtool File 478.34 KB 0755
g++ File 1.21 MB 0755
g13 File 211.98 KB 0755
galera_new_cluster File 932 B 0755
galera_recovery File 3.29 KB 0755
gapplication File 20.45 KB 0755
garb-systemd File 1.31 KB 0755
garbd File 1.65 MB 0755
gawk File 669.77 KB 0755
gc File 16.64 KB 0755
gcc File 1.21 MB 0755
gcc-ar File 36.66 KB 0755
gcc-nm File 36.66 KB 0755
gcc-ranlib File 36.66 KB 0755
gcov File 1.31 MB 0755
gcov-dump File 570.96 KB 0755
gcov-tool File 607.77 KB 0755
gdbm_dump File 21.05 KB 0755
gdbm_load File 25.31 KB 0755
gdbmtool File 111.57 KB 0755
gdbus File 48.72 KB 0755
gdk-pixbuf-query-loaders-64 File 15.93 KB 0755
gdk-pixbuf-thumbnailer File 20.45 KB 0755
gdlib-config File 2.79 KB 0755
gencat File 24.84 KB 0755
genl-ctrl-list File 12.04 KB 0755
geqn File 232.16 KB 0755
getconf File 32.46 KB 0755
getent File 33.13 KB 0755
getfacl File 25.38 KB 0755
getkeycodes File 12.54 KB 0755
getmodule File 6.3 MB 0775
getopt File 20.53 KB 0755
getopts File 31 B 0755
gettext File 48.97 KB 0755
gettext.sh File 4.52 KB 0755
gettextize File 42.69 KB 0755
ghostscript File 12.35 KB 0755
gio File 85.22 KB 0755
gio-querymodules-64 File 16.3 KB 0755
git File 26.38 MB 0755
git-receive-pack File 26.38 MB 0755
git-shell File 15.79 MB 0755
git-upload-archive File 26.38 MB 0755
git-upload-pack File 26.38 MB 0755
glib-compile-schemas File 48.85 KB 0755
gmake File 235.32 KB 0755
gml2gv File 41.23 KB 0755
gneqn File 908 B 0755
gnroff File 3.23 KB 0755
gpasswd File 82.17 KB 4755
gpg File 1.04 MB 0755
gpg-agent File 419.3 KB 0755
gpg-connect-agent File 165.3 KB 0755
gpg-error File 34.16 KB 0755
gpg-error-config File 2.26 KB 0755
gpg-wks-server File 206.71 KB 0755
gpg-zip File 3.44 KB 0755
gpg2 File 1.04 MB 0755
gpgconf File 176.1 KB 0755
gpgme-json File 85.68 KB 0755
gpgparsemail File 28.74 KB 0755
gpgrt-config File 2.26 KB 0755
gpgsm File 514.46 KB 0755
gpgsplit File 87.02 KB 0755
gpgv File 451.51 KB 0755
gpgv2 File 451.51 KB 0755
gpic File 293.84 KB 0755
gpio-event-mon File 14.96 KB 0755
gpio-hammer File 14.96 KB 0755
gprof File 103.35 KB 0755
gr2fonttest File 29.95 KB 0755
graphml2gv File 20.65 KB 0755
grep File 193.63 KB 0755
groff File 124.92 KB 0755
grops File 191.14 KB 0755
grotty File 141.9 KB 0755
groups File 37.39 KB 0755
grub2-editenv File 448.09 KB 0755
grub2-file File 928.53 KB 0755
grub2-fstest File 1.15 MB 0755
grub2-glue-efi File 279.41 KB 0755
grub2-kbdcomp File 1.63 KB 0755
grub2-menulst2cfg File 262.65 KB 0755
grub2-mkfont File 312.12 KB 0755
grub2-mkimage File 431.41 KB 0755
grub2-mklayout File 289.48 KB 0755
grub2-mknetdir File 485.75 KB 0755
grub2-mkpasswd-pbkdf2 File 291.88 KB 0755
grub2-mkrelpath File 279.27 KB 0755
grub2-mkrescue File 1.12 MB 0755
grub2-mkstandalone File 594.31 KB 0755
grub2-render-label File 937.13 KB 0755
grub2-script-check File 316 KB 0755
grub2-syslinux2cfg File 861.61 KB 0755
gs File 12.35 KB 0755
gsettings File 28.61 KB 0755
gsnd File 277 B 0755
gsoelim File 42.55 KB 0755
gss-client File 24.56 KB 0755
gtar File 448.99 KB 0755
gtbl File 154.61 KB 0755
gtk-query-immodules-2.0-64 File 16.29 KB 0755
gtk-update-icon-cache File 33.03 KB 0755
gtroff File 805.02 KB 0755
gunzip File 2.29 KB 0755
gv2gml File 24.7 KB 0755
gv2gxl File 41.3 KB 0755
gvcolor File 46.9 KB 0755
gvgen File 24.8 KB 0755
gvmap File 526.31 KB 0755
gvmap.sh File 2.14 KB 0755
gvpack File 460.59 KB 0755
gvpr File 7.83 KB 0755
gxl2dot File 41.3 KB 0755
gxl2gv File 41.3 KB 0755
gzexe File 6.23 KB 0755
gzip File 94.67 KB 0755
h2ph File 28.69 KB 0755
h2xs File 59.44 KB 0755
hash File 28 B 0755
head File 45.5 KB 0755
hexdump File 57.51 KB 0755
hmac256 File 16.86 KB 0755
host File 142.3 KB 0755
hostid File 33.34 KB 0755
hostname File 21.16 KB 0755
hostnamectl File 20.83 KB 0755
htdbm File 31.72 KB 0755
htdigest File 21.71 KB 0755
html2text File 406 B 0755
htpasswd File 31.55 KB 0755
httxt2dbm File 21.1 KB 0755
hunspell File 144.7 KB 0755
i386 File 20.76 KB 0755
iceauth File 41.87 KB 0755
iconv File 61.43 KB 0755
id File 45.44 KB 0755
identify File 11.84 KB 0755
idiag-socket-details File 12.09 KB 0755
idle2 File 93 B 0755
idle2.7 File 93 B 0755
idn File 39.41 KB 0755
ifnames File 4.03 KB 0755
iio_event_monitor File 22.98 KB 0755
iio_generic_buffer File 26.98 KB 0755
import File 11.84 KB 0755
imunify-agent-proxy File 13.11 MB 0755
imunify-antivirus File 1 KB 0755
imunify-fgw-dump File 7.8 MB 0755
imunify-service File 1020 B 0755
imunify360-agent File 1 KB 0755
imunify360-command-wrapper File 9.99 KB 0755
info File 249.89 KB 0755
infocmp File 61.05 KB 0755
infotocap File 85.31 KB 0755
innochecksum File 4.54 MB 0755
install File 156.16 KB 0755
instmodsh File 4.1 KB 0755
intel-speed-select File 93.02 KB 0755
ionice File 28.98 KB 0755
iostat File 57.69 KB 0755
ipcalc File 46.08 KB 0755
ipcmk File 29.14 KB 0755
ipcrm File 28.99 KB 0755
ipcs File 53.4 KB 0755
isc-config.sh File 3.33 KB 0755
isosize File 24.88 KB 0755
ispell File 988 B 0755
isql File 36.58 KB 0755
iusql File 28.66 KB 0755
jcat-tool File 40.91 KB 0755
jobs File 28 B 0755
join File 53.7 KB 0755
journalctl File 77 KB 0755
json_pp File 4.19 KB 0755
json_reformat File 16.55 KB 0755
json_verify File 12.27 KB 0755
json_xs File 6.84 KB 0755
kbd_mode File 12.55 KB 0755
kbdinfo File 16.56 KB 0755
kbdrate File 16.45 KB 0755
kbxutil File 177.35 KB 0755
kdumpctl File 32.93 KB 0755
kernel-install File 4.41 KB 0755
keyctl File 36.82 KB 0755
kill File 37.28 KB 0755
killall File 29.77 KB 0755
kmod File 159.95 KB 0755
krb5-config File 6.98 KB 0755
kvm_stat File 60.85 KB 0755
last File 49.23 KB 0755
lastb File 49.23 KB 0755
lastlog File 20.63 KB 0755
lchfn File 20.35 KB 0755
lchsh File 16.35 KB 0755
ld File 1.71 MB 0755
ld.bfd File 1.71 MB 0755
ld.gold File 2.35 MB 0755
ld.so File 1.05 MB 0755
ldd File 5.31 KB 0755
lefty File 304.52 KB 0755
less File 173.76 KB 0755
lessecho File 12.4 KB 0755
lesskey File 21.99 KB 0755
lesspipe.sh File 3.07 KB 0755
lex File 428.45 KB 0755
lexgrog File 93.7 KB 0755
libgcrypt-config File 3.84 KB 0755
libnetcfg File 15.41 KB 0755
libpng-config File 2.33 KB 0755
libpng16-config File 2.33 KB 0755
libtool File 359.11 KB 0755
libtoolize File 126.17 KB 0755
libwmf-fontmap File 13.03 KB 0755
link File 33.34 KB 0755
linux-boot-prober File 5.85 KB 0755
linux32 File 20.76 KB 0755
linux64 File 20.76 KB 0755
ln File 70.5 KB 0755
lneato File 1.51 KB 0755
loadkeys File 210.53 KB 0755
loadunimap File 29.03 KB 0755
locale File 56.44 KB 0755
localectl File 28.86 KB 0755
localedef File 307.47 KB 0755
logger File 49.98 KB 0755
login File 40.96 KB 0755
loginctl File 57.28 KB 0755
logname File 33.34 KB 0755
logresolve File 21.45 KB 0755
look File 16.46 KB 0755
lp File 20.38 KB 0755
lp.cups File 20.38 KB 0755
lpoptions File 19.91 KB 0755
lpq File 20.42 KB 0755
lpq.cups File 20.42 KB 0755
lpr File 15.86 KB 0755
lpr.cups File 15.86 KB 0755
lprm File 11.86 KB 0755
lprm.cups File 11.86 KB 0755
lpstat File 32.77 KB 0755
lpstat.cups File 32.77 KB 0755
ls File 139.91 KB 0755
lsattr File 11.93 KB 0755
lsb_release File 15.56 KB 0755
lsblk File 90.14 KB 0755
lscpu File 81.7 KB 0755
lsgpio File 15.06 KB 0755
lsiio File 22.98 KB 0755
lsinitrd File 8.68 KB 0755
lsipc File 73.74 KB 0755
lslocks File 37.53 KB 0755
lslogins File 65.62 KB 0755
lsmem File 45.34 KB 0755
lsns File 49.29 KB 0755
lsof File 175.4 KB 0755
lsphp File 937 B 0755
lsscsi File 86.01 KB 0755
lua File 20.45 KB 0755
luac File 152.77 KB 0755
lwp-download File 10.05 KB 0755
lwp-dump File 2.65 KB 0755
lwp-mirror File 2.36 KB 0755
lwp-request File 15.84 KB 0755
m4 File 185.56 KB 0755
mail File 408.89 KB 0755
mailx File 408.89 KB 0755
make File 235.32 KB 0755
make-dummy-cert File 610 B 0755
makedb File 24.84 KB 0755
man File 112.52 KB 0755
mandb File 134.52 KB 0755
manpath File 33.42 KB 0755
mapscrn File 24.84 KB 0755
mariadb File 5.24 MB 0755
mariadb-access File 109.34 KB 0755
mariadb-admin File 4.8 MB 0755
mariadb-binlog File 5.07 MB 0755
mariadb-check File 4.8 MB 0755
mariadb-config File 12.2 KB 0755
mariadb-conv File 4.53 MB 0755
mariadb-convert-table-format File 4.12 KB 0755
mariadb-dump File 4.89 MB 0755
mariadb-dumpslow File 8.05 KB 0755
mariadb-embedded File 23.7 MB 0755
mariadb-find-rows File 3.21 KB 0755
mariadb-fix-extensions File 1.22 KB 0755
mariadb-hotcopy File 34.53 KB 0755
mariadb-import File 4.79 MB 0755
mariadb-install-db File 22.14 KB 0755
mariadb-plugin File 4.51 MB 0755
mariadb-secure-installation File 13.48 KB 0755
mariadb-service-convert File 2.45 KB 0755
mariadb-setpermission File 17.56 KB 0755
mariadb-show File 4.79 MB 0755
mariadb-slap File 4.81 MB 0755
mariadb-tzinfo-to-sql File 4.51 MB 0755
mariadb-upgrade File 4.94 MB 0755
mariadb-waitpid File 4.5 MB 0755
mariadb_config File 12.2 KB 0755
mariadbd-multi File 26.71 KB 0755
mariadbd-safe File 30.42 KB 0755
mariadbd-safe-helper File 4.47 MB 0755
mcookie File 33.27 KB 0755
mcpp File 9.02 KB 0755
md5sum File 45.54 KB 0755
mdig File 48.52 KB 0755
memstrack File 83.78 KB 0755
mesg File 16.36 KB 0755
mkdir File 82.7 KB 0755
mkfifo File 66.46 KB 0755
mkfontdir File 65 B 0755
mkfontscale File 41.59 KB 0755
mkinitrd File 6.43 KB 0755
mknod File 70.47 KB 0755
mktemp File 45.66 KB 0755
mm2gv File 90.53 KB 0755
mmdblookup File 16.74 KB 0755
modulecmd File 384.75 KB 0755
modulemd-validator File 24.96 KB 0755
modutil File 177.43 KB 0755
mogrify File 11.84 KB 0755
mokutil File 49.98 KB 0755
montage File 11.84 KB 0755
more File 44.94 KB 0755
mount File 49.15 KB 4755
mountpoint File 16.48 KB 0755
mpicalc File 20.38 KB 0755
mpstat File 53.51 KB 0755
msgattrib File 25.58 KB 0755
msgcat File 25.55 KB 0755
msgcmp File 26.12 KB 0755
msgcomm File 25.55 KB 0755
msgconv File 21.55 KB 0755
msgen File 21.55 KB 0755
msgexec File 21.55 KB 0755
msgfilter File 34.53 KB 0755
msgfmt File 90.3 KB 0755
msgfmt2.7.py File 6.33 KB 0755
msgfmt2.py File 6.33 KB 0755
msggrep File 43.6 KB 0755
msginit File 67.85 KB 0755
msgmerge File 71.48 KB 0755
msgunfmt File 35.8 KB 0755
msguniq File 25.56 KB 0755
msql2mysql File 1.41 KB 0755
mv File 143.96 KB 0755
my_print_defaults File 4.5 MB 0755
myisam_ftdump File 4.79 MB 0755
myisamchk File 4.91 MB 0755
myisamlog File 4.77 MB 0755
myisampack File 4.81 MB 0755
mysql File 5.24 MB 0755
mysql_config File 4.51 KB 0755
mysql_embedded File 23.7 MB 0755
mysql_find_rows File 3.21 KB 0755
mysql_fix_extensions File 1.22 KB 0755
mysql_install_db File 22.14 KB 0755
mysql_plugin File 4.51 MB 0755
mysql_tzinfo_to_sql File 4.51 MB 0755
mysql_upgrade File 4.94 MB 0755
mysql_waitpid File 4.5 MB 0755
mysqlaccess File 109.34 KB 0755
mysqladmin File 4.8 MB 0755
mysqlbinlog File 5.07 MB 0755
mysqlcheck File 4.8 MB 0755
mysqld_multi File 26.71 KB 0755
mysqld_safe File 30.42 KB 0755
mysqld_safe_helper File 4.47 MB 0755
mysqldump File 4.89 MB 0755
mysqlimport File 4.79 MB 0755
mysqlshow File 4.79 MB 0755
mysqlslap File 4.81 MB 0755
mytop File 72.03 KB 0755
nail File 408.89 KB 0755
named-rrchecker File 19.88 KB 0755
namei File 33.1 KB 0755
nano File 247.94 KB 0755
nc File 49.39 KB 0755
ncurses6-config File 5.87 KB 0755
ncursesw6-config File 5.88 KB 0755
ndptool File 24.45 KB 0755
neato File 12.26 KB 0755
needs-restarting File 3.62 KB 0755
neqn File 908 B 0755
netcat File 49.39 KB 0755
netstat File 158.68 KB 0755
newgidmap File 47.81 KB 0755
newgrp File 42.46 KB 4755
newuidmap File 47.77 KB 0755
nf-ct-add File 16.46 KB 0755
nf-ct-events File 12.38 KB 0755
nf-ct-list File 16.49 KB 0755
nf-exp-add File 16.87 KB 0755
nf-exp-delete File 16.66 KB 0755
nf-exp-list File 16.49 KB 0755
nf-log File 12.35 KB 0755
nf-monitor File 12.36 KB 0755
nf-queue File 16.35 KB 0755
ngettext File 48.97 KB 0755
nice File 37.33 KB 0755
nisdomainname File 21.16 KB 0755
nl File 45.55 KB 0755
nl-addr-add File 12.34 KB 0755
nl-addr-delete File 16.77 KB 0755
nl-addr-list File 16.88 KB 0755
nl-class-add File 16.73 KB 0755
nl-class-delete File 12.63 KB 0755
nl-class-list File 12.59 KB 0755
nl-classid-lookup File 12.47 KB 0755
nl-cls-add File 16.77 KB 0755
nl-cls-delete File 16.77 KB 0755
nl-cls-list File 12.73 KB 0755
nl-fib-lookup File 12.5 KB 0755
nl-link-enslave File 11.87 KB 0755
nl-link-ifindex2name File 11.87 KB 0755
nl-link-list File 12.23 KB 0755
nl-link-name2ifindex File 11.86 KB 0755
nl-link-release File 11.86 KB 0755
nl-link-set File 12.77 KB 0755
nl-link-stats File 12.59 KB 0755
nl-list-caches File 12.27 KB 0755
nl-list-sockets File 11.87 KB 0755
nl-monitor File 12.52 KB 0755
nl-neigh-add File 12.63 KB 0755
nl-neigh-delete File 12.66 KB 0755
nl-neigh-list File 12.19 KB 0755
nl-neightbl-list File 12.01 KB 0755
nl-pktloc-lookup File 12.56 KB 0755
nl-qdisc-add File 12.65 KB 0755
nl-qdisc-delete File 12.63 KB 0755
nl-qdisc-list File 16.74 KB 0755
nl-route-add File 16.39 KB 0755
nl-route-delete File 16.88 KB 0755
nl-route-get File 12.35 KB 0755
nl-route-list File 16.44 KB 0755
nl-rule-list File 12.05 KB 0755
nl-tctree-list File 12.66 KB 0755
nl-util-addr File 11.85 KB 0755
nm File 50.38 KB 0755
nm-online File 20.84 KB 0755
nmcli File 1009 KB 0755
nmtui File 784.12 KB 0755
nmtui-connect File 784.12 KB 0755
nmtui-edit File 784.12 KB 0755
nmtui-hostname File 784.12 KB 0755
nohup File 37.41 KB 0755
nop File 12.5 KB 0755
nproc File 37.41 KB 0755
nroff File 3.23 KB 0755
nsenter File 33.3 KB 0755
nslookup File 146.26 KB 0755
nss-policy-check File 16.3 KB 0755
nsupdate File 73.05 KB 0755
numfmt File 65.64 KB 0755
objcopy File 240.07 KB 0755
objdump File 419.76 KB 0755
od File 73.8 KB 0755
odbc_config File 11.84 KB 0755
odbcinst File 28.88 KB 0755
open File 20.97 KB 0755
openssl File 745.95 KB 0755
openvt File 20.97 KB 0755
os-prober File 5.78 KB 0755
osage File 12.26 KB 0755
p11-kit File 37.15 KB 0755
package-cleanup File 3.62 KB 0755
page_owner_sort File 11.34 KB 0755
pango-list File 11.88 KB 0755
pango-view File 57.44 KB 0755
paperconf File 13.07 KB 0755
passwd File 32.77 KB 4755
paste File 37.4 KB 0755
patch File 206.46 KB 0755
patchwork File 12.26 KB 0755
pathchk File 37.34 KB 0755
pathfix.py File 6.63 KB 0755
pax File 394.61 KB 0755
pcre2-config File 1.9 KB 0755
pdf2dsc File 698 B 0755
pdf2ps File 909 B 0755
pdns_control File 486.11 KB 0755
pdnsutil File 5.19 MB 0755
peekfd File 16.51 KB 0755
perl File 12.43 KB 0755
perl5.26.3 File 12.43 KB 0755
perlbug File 44.39 KB 0755
perldoc File 118 B 0755
perlivp File 10.56 KB 0755
perlml File 6.61 KB 0755
perlthanks File 44.39 KB 0755
perror File 4.7 MB 0755
pflags File 2.57 KB 0755
pftp File 101.2 KB 0755
pgrep File 28.84 KB 0755
php File 937 B 0755
pic File 293.84 KB 0755
piconv File 8.08 KB 0755
pidof File 16.7 KB 0755
pidstat File 65.72 KB 0755
pigz File 125.38 KB 0755
pinentry File 2.35 KB 0755
pinentry-curses File 77.89 KB 0755
ping File 66.13 KB 0755
pinky File 41.46 KB 0755
pip-2 File 206 B 0755
pip-2.7 File 206 B 0755
pip-3 File 209 B 0755
pip-3.6 File 209 B 0755
pip2 File 206 B 0755
pip2.7 File 206 B 0755
pip3 File 209 B 0755
pip3.6 File 209 B 0755
pk12util File 111.12 KB 0755
pkaction File 16.38 KB 0755
pkcheck File 24.43 KB 0755
pkexec File 28.41 KB 0755
pkg-config File 40.04 KB 0755
pkgconf File 40.04 KB 0755
pkill File 28.84 KB 0755
pkla-admin-identities File 25.72 KB 0755
pkla-check-authorization File 33.78 KB 0755
pkttyagent File 20.38 KB 0755
pl2pm File 4.43 KB 0755
pldd File 16.75 KB 0755
plesk_configure File 342 B 0755
plymouth File 45.24 KB 0755
pmap File 32.78 KB 0755
png-fix-itxt File 11.85 KB 0755
pngfix File 52.85 KB 0755
pod2html File 4.04 KB 0755
pod2man File 14.68 KB 0755
pod2text File 10.55 KB 0755
pod2usage File 3.86 KB 0755
podchecker File 3.57 KB 0755
podselect File 2.47 KB 0755
post-grohtml File 238.73 KB 0755
powernow-k8-decode File 10.88 KB 0755
pr File 82.15 KB 0755
pre-grohtml File 130.55 KB 0755
precat File 5.52 KB 0755
preconv File 57.65 KB 0755
preunzip File 5.52 KB 0755
prezip File 5.52 KB 0755
prezip-bin File 11.98 KB 0755
printenv File 33.32 KB 0755
printf File 53.56 KB 0755
prlimit File 37.54 KB 0755
procan File 82.6 KB 0755
protoc File 16.49 KB 0755
protoc-c File 244.79 KB 0755
protoc-gen-c File 244.79 KB 0755
prove File 13.24 KB 0755
prtstat File 20.51 KB 0755
prune File 16.73 KB 0755
ps File 134.75 KB 0755
ps2ascii File 631 B 0755
ps2epsi File 2.69 KB 0755
ps2pdf File 272 B 0755
ps2pdf12 File 215 B 0755
ps2pdf13 File 215 B 0755
ps2pdf14 File 215 B 0755
ps2pdfwr File 1.07 KB 0755
ps2ps File 647 B 0755
ps2ps2 File 669 B 0755
psfaddtable File 20.66 KB 0755
psfgettable File 20.66 KB 0755
psfstriptable File 20.66 KB 0755
psfxtable File 20.66 KB 0755
pslog File 12.48 KB 0755
pstree File 33.53 KB 0755
pstree.x11 File 33.53 KB 0755
ptar File 3.38 KB 0755
ptardiff File 2.48 KB 0755
ptargrep File 4.2 KB 0755
ptx File 78 KB 0755
pure-pw File 38.84 KB 0755
pure-pwconvert File 10.72 KB 0755
pure-statsdecode File 10.72 KB 0755
pv File 73.56 KB 0755
pwd File 37.42 KB 0755
pwdx File 12.68 KB 0755
pwmake File 12.27 KB 0755
pwscore File 12.27 KB 0755
pydoc-3 File 89 B 0755
pydoc2 File 78 B 0755
pydoc2.7 File 78 B 0755
pydoc3 File 89 B 0755
pydoc3.12 File 79 B 0755
pydoc3.6 File 89 B 0755
pygettext2.7.py File 21.56 KB 0755
pygettext2.py File 21.56 KB 0755
pynche2 File 138 B 0755
pynche2.7 File 138 B 0755
python-html2text File 406 B 0755
python2 File 7.84 KB 0755
python2-config File 1.8 KB 0755
python2.7 File 7.84 KB 0755
python2.7-config File 1.8 KB 0755
python3 File 11.59 KB 0755
python3-config File 204 B 0755
python3-html2text File 406 B 0755
python3.12 File 7.57 KB 0755
python3.6 File 11.59 KB 0755
python3.6-config File 204 B 0755
python3.6m File 11.59 KB 0755
python3.6m-config File 204 B 0755
python3.6m-x86_64-config File 3.54 KB 0755
pyvenv-3 File 446 B 0755
pyvenv-3.6 File 446 B 0755
quota File 91.49 KB 4755
quotasync File 74.69 KB 0755
r1soft-report.sh File 9.55 KB 0500
r1soft-setup File 5.75 MB 0500
r1soft-setup-old File 2.39 MB 0500
ranlib File 61.97 KB 0755
raw File 16.5 KB 0755
read File 28 B 0755
readelf File 624.54 KB 0755
readlink File 45.88 KB 0755
realpath File 49.94 KB 0755
recode-sr-latin File 17.99 KB 0755
red File 89 B 0755
redhat_lsb_init File 576 B 0644
rename File 16.5 KB 0755
renew-dummy-cert File 725 B 0755
renice File 16.46 KB 0755
replace File 4.48 MB 0755
repo-graph File 3.62 KB 0755
repoclosure File 3.62 KB 0755
repodiff File 3.62 KB 0755
repomanage File 3.62 KB 0755
repoquery File 3.62 KB 0755
reposync File 3.62 KB 0755
repotrack File 3.62 KB 0755
rescan-scsi-bus.sh File 38.24 KB 0755
reset File 24.76 KB 0755
resizecons File 20.77 KB 0755
resolve_stack_dump File 4.5 MB 0755
resolvectl File 195.75 KB 0755
resolveip File 4.5 MB 0755
rev File 12.46 KB 0755
rm File 70.38 KB 0755
rmdir File 45.46 KB 0755
rnano File 247.94 KB 0755
rpcbind File 61.55 KB 0755
rpcinfo File 32.64 KB 0755
rpm File 20.85 KB 0755
rpm2archive File 20.46 KB 0755
rpm2cpio File 11.84 KB 0755
rpmdb File 16.96 KB 0755
rpmkeys File 16.87 KB 0755
rpmquery File 20.85 KB 0755
rpmverify File 20.85 KB 0755
rsync File 510.14 KB 0755
rsyslog-recover-qi.pl File 5.96 KB 0755
run-parts File 1.94 KB 0755
run-with-aspell File 85 B 0755
runcon File 37.38 KB 0755
rvi File 1.13 MB 0755
rview File 1.13 MB 0755
sadf File 334.57 KB 0755
sar File 135.77 KB 0755
sccmap File 20.62 KB 0755
scl File 36.87 KB 0755
scl_enabled File 258 B 0755
scl_source File 1.82 KB 0755
scp File 102.84 KB 0755
screen File 482.46 KB 2755
script File 36.8 KB 0755
scriptreplay File 29 KB 0755
scsi-rescan File 38.24 KB 0755
scsi_logging_level File 8.38 KB 0755
scsi_mandat File 3.52 KB 0755
scsi_readcap File 1.3 KB 0755
scsi_ready File 1.09 KB 0755
scsi_satl File 3.77 KB 0755
scsi_start File 1.25 KB 0755
scsi_stop File 1.44 KB 0755
scsi_temperature File 936 B 0755
sdiff File 105.33 KB 0755
secon File 25.46 KB 0755
secret-tool File 21.17 KB 0755
sed File 115.27 KB 0755
semodule_expand File 12.28 KB 0755
semodule_link File 12.28 KB 0755
semodule_package File 16.68 KB 0755
semodule_unpackage File 12.3 KB 0755
seq File 53.45 KB 0755
serverbackup-setup File 5.75 MB 0500
sessreg File 17.38 KB 0755
setarch File 20.76 KB 0755
setfacl File 37.65 KB 0755
setfont File 45.19 KB 0755
setkeycodes File 12.56 KB 0755
setleds File 16.6 KB 0755
setmetamode File 12.56 KB 0755
setpriv File 45.16 KB 0755
setsid File 16.38 KB 0755
setterm File 45.13 KB 0755
setup-nsssysinit File 1.5 KB 0755
setup-nsssysinit.sh File 1.5 KB 0755
setvtrgb File 16.64 KB 0755
sfdp File 12.26 KB 0755
sftp File 159.74 KB 0755
sg File 42.46 KB 4755
sg_bg_ctl File 16.07 KB 0755
sg_compare_and_write File 20.9 KB 0755
sg_copy_results File 20.81 KB 0755
sg_dd File 44.58 KB 0755
sg_decode_sense File 20.33 KB 0755
sg_emc_trespass File 12.26 KB 0755
sg_format File 33.37 KB 0755
sg_get_config File 33.31 KB 0755
sg_get_lba_status File 20.46 KB 0755
sg_ident File 16.17 KB 0755
sg_inq File 117.91 KB 0755
sg_logs File 150.02 KB 0755
sg_luns File 24.85 KB 0755
sg_map File 16.41 KB 0755
sg_map26 File 24.87 KB 0755
sg_modes File 43.88 KB 0755
sg_opcodes File 28.69 KB 0755
sg_persist File 34.13 KB 0755
sg_prevent File 12.07 KB 0755
sg_raw File 24.38 KB 0755
sg_rbuf File 20.84 KB 0755
sg_rdac File 15.88 KB 0755
sg_read File 24.41 KB 0755
sg_read_attr File 34.79 KB 0755
sg_read_block_limits File 12.12 KB 0755
sg_read_buffer File 20.96 KB 0755
sg_read_long File 16.27 KB 0755
sg_readcap File 20.86 KB 0755
sg_reassign File 16.22 KB 0755
sg_referrals File 16.23 KB 0755
sg_rep_zones File 20.66 KB 0755
sg_requests File 16.3 KB 0755
sg_reset File 16.73 KB 0755
sg_reset_wp File 16.17 KB 0755
sg_rmsn File 12.06 KB 0755
sg_rtpg File 16.16 KB 0755
sg_safte File 20.27 KB 0755
sg_sanitize File 24.58 KB 0755
sg_sat_identify File 16.71 KB 0755
sg_sat_phy_event File 20.59 KB 0755
sg_sat_read_gplog File 16.3 KB 0755
sg_sat_set_features File 16.27 KB 0755
sg_scan File 16.5 KB 0755
sg_seek File 16.85 KB 0755
sg_senddiag File 25.27 KB 0755
sg_ses File 118.23 KB 0755
sg_ses_microcode File 29.48 KB 0755
sg_start File 20.93 KB 0755
sg_stpg File 20.3 KB 0755
sg_stream_ctl File 20.27 KB 0755
sg_sync File 16.22 KB 0755
sg_test_rwbuf File 20.73 KB 0755
sg_timestamp File 20.74 KB 0755
sg_turs File 16.74 KB 0755
sg_unmap File 24.32 KB 0755
sg_verify File 20.46 KB 0755
sg_vpd File 108.75 KB 0755
sg_wr_mode File 20.3 KB 0755
sg_write_buffer File 21.24 KB 0755
sg_write_long File 16.33 KB 0755
sg_write_same File 24.48 KB 0755
sg_write_verify File 20.78 KB 0755
sg_write_x File 53.75 KB 0755
sg_xcopy File 40.59 KB 0755
sg_zone File 16.3 KB 0755
sginfo File 74.85 KB 0755
sgm_dd File 32.55 KB 0755
sgp_dd File 36.95 KB 0755
sh File 1.1 MB 0755
sha1hmac File 32.66 KB 0755
sha1sum File 45.55 KB 0755
sha224hmac File 32.66 KB 0755
sha224sum File 45.58 KB 0755
sha256hmac File 32.66 KB 0755
sha256sum File 45.58 KB 0755
sha384hmac File 32.66 KB 0755
sha384sum File 45.59 KB 0755
sha512hmac File 32.66 KB 0755
sha512sum File 45.59 KB 0755
shasum File 9.66 KB 0755
showconsolefont File 20.73 KB 0755
showkey File 16.58 KB 0755
showrgb File 13.05 KB 0755
shred File 61.85 KB 0755
shuf File 58.09 KB 0755
sieve-dump File 30.84 KB 0755
sieve-filter File 40.27 KB 0755
sieve-test File 40.2 KB 0755
sievec File 35.1 KB 0755
signver File 114.79 KB 0755
sim_client File 16.27 KB 0755
size File 33.25 KB 0755
skill File 28.8 KB 0755
slabinfo File 36.15 KB 0755
slabtop File 20.84 KB 0755
sleep File 37.4 KB 0755
slencheck File 12.29 KB 0755
sm3hmac File 32.66 KB 0755
smtpd2.7.py File 18.11 KB 0755
smtpd2.py File 18.11 KB 0755
snice File 28.8 KB 0755
socat File 406.49 KB 0755
soelim File 42.55 KB 0755
sort File 123.48 KB 0755
sotruss File 4.18 KB 0755
spax File 394.61 KB 0755
spell File 122 B 0755
splain File 18.7 KB 0755
split File 58.05 KB 0755
sprof File 28.67 KB 0755
sqlite3 File 1.28 MB 0755
ssh File 757.61 KB 0755
ssh-add File 346.13 KB 0755
ssh-agent File 325.59 KB 0755
ssh-copy-id File 10.44 KB 0755
ssh-keygen File 427.17 KB 0755
ssh-keyscan File 432.59 KB 0755
ssltap File 130.51 KB 0755
sss_ssh_authorizedkeys File 28.78 KB 0755
sss_ssh_knownhostsproxy File 28.78 KB 0755
stat File 86.16 KB 0755
stdbuf File 49.5 KB 0755
strace File 1.94 MB 0755
strace-log-merge File 1.78 KB 0755
stream File 11.83 KB 0755
strings File 37.43 KB 0755
strip File 240.09 KB 0755
stty File 77.61 KB 0755
su File 48.99 KB 4750
sudo File 186.52 KB 4111
sudoedit File 186.52 KB 4111
sudoreplay File 119.2 KB 0111
sum File 45.53 KB 0755
sw-engine File 20.12 MB 0755
sxpm File 28.81 KB 0755
sync File 37.35 KB 0755
systemctl File 218.45 KB 0755
systemd-analyze File 1.56 MB 0755
systemd-ask-password File 12.02 KB 0755
systemd-cat File 16.03 KB 0755
systemd-cgls File 16.44 KB 0755
systemd-cgtop File 32.88 KB 0755
systemd-delta File 24.45 KB 0755
systemd-detect-virt File 11.88 KB 0755
systemd-escape File 16.01 KB 0755
systemd-firstboot File 36.98 KB 0755
systemd-hwdb File 28.91 KB 0755
systemd-inhibit File 16.03 KB 0755
systemd-machine-id-setup File 24.75 KB 0755
systemd-mount File 52.63 KB 0755
systemd-notify File 16.03 KB 0755
systemd-path File 16.02 KB 0755
systemd-resolve File 195.75 KB 0755
systemd-run File 48.95 KB 0755
systemd-socket-activate File 24.77 KB 0755
systemd-stdio-bridge File 16.02 KB 0755
systemd-sysusers File 53.05 KB 0755
systemd-tmpfiles File 73.3 KB 0755
systemd-tty-ask-password-agent File 32.82 KB 0755
systemd-umount File 52.63 KB 0755
tabs File 16.55 KB 0755
tac File 41.49 KB 0755
tail File 74.13 KB 0755
tapestat File 41.32 KB 0755
tar File 448.99 KB 0755
taskset File 37.26 KB 0755
tbl File 154.61 KB 0755
tclsh File 9.04 KB 0755
tclsh8.6 File 9.04 KB 0755
tcptraceroute File 1.55 KB 0755
teamd File 160.52 KB 0755
teamdctl File 30.37 KB 0755
teamnl File 20.47 KB 0755
tee File 41.48 KB 0755
telnet File 104.88 KB 0755
test File 53.55 KB 0755
tic File 85.31 KB 0755
time File 27.54 KB 0755
timedatectl File 36.96 KB 0755
timeout File 41.85 KB 0755
tload File 16.76 KB 0755
tmon File 39.63 KB 0755
tmpwatch File 35.47 KB 0755
toe File 16.45 KB 0755
top File 121.7 KB 0755
touch File 93.94 KB 0755
tput File 24.8 KB 0755
tr File 49.63 KB 0755
tracepath File 20.44 KB 0755
traceroute File 70.97 KB 0755
traceroute6 File 70.97 KB 0755
tred File 16.59 KB 0755
troff File 805.02 KB 0755
true File 33.33 KB 0755
truncate File 41.36 KB 0755
trust File 219.55 KB 0755
tset File 24.76 KB 0755
tsort File 41.49 KB 0755
tty File 33.31 KB 0755
turbostat File 130.8 KB 0755
twopi File 12.26 KB 0755
type File 28 B 0755
tzselect File 15.01 KB 0755
uapi File 3.33 MB 0755
ucs2any File 24.41 KB 0755
udevadm File 424.56 KB 0755
udisksctl File 60.73 KB 0755
ul File 20.59 KB 0755
ulimit File 30 B 0755
umask File 29 B 0755
umount File 32.75 KB 4755
unalias File 31 B 0755
uname File 37.33 KB 0755
uname26 File 20.76 KB 0755
unexpand File 45.61 KB 0755
unflatten File 16.63 KB 0755
unicode_start File 2.55 KB 0755
unicode_stop File 363 B 0755
uniq File 49.64 KB 0755
unlink File 33.34 KB 0755
unpigz File 125.38 KB 0755
unshare File 24.93 KB 0755
unversioned-python File 157 B 0755
unxz File 82.09 KB 0755
unzip File 201.88 KB 0755
unzipsfx File 101.48 KB 0755
update-ca-trust File 1.24 KB 0755
update-crypto-policies File 87 B 0755
update-gtk-immodules File 313 B 0755
update-mime-database File 57.22 KB 0755
uptime File 12.59 KB 0755
users File 37.4 KB 0755
usleep File 11.86 KB 0755
utmpdump File 28.66 KB 0755
uuclient File 15.88 KB 0755
uuidgen File 16.38 KB 0755
uuidparse File 37.13 KB 0755
vdir File 139.91 KB 0755
vi File 1.13 MB 0755
view File 1.13 MB 0755
vimdot File 1.06 KB 0755
vlock File 20.83 KB 0755
vmstat File 36.79 KB 0755
w File 20.75 KB 0755
wait File 28 B 0755
wall File 33.05 KB 0755
watch File 29.19 KB 0755
watchgnupg File 16.44 KB 0755
wc File 49.64 KB 0755
wdctl File 36.98 KB 0755
wget File 521.41 KB 0755
whatis File 54.04 KB 0755
whereis File 29.27 KB 0755
which File 29.38 KB 0755
whiptail File 33.09 KB 0755
who File 53.59 KB 0755
whoami File 33.34 KB 0755
wish File 13.05 KB 0755
wish8.6 File 13.05 KB 0755
wmf2eps File 17.15 KB 0755
wmf2fig File 17.15 KB 0755
wmf2gd File 17.14 KB 0755
wmf2svg File 17.16 KB 0755
wmf2x File 17.13 KB 0755
word-list-compress File 11.99 KB 0755
write File 20.62 KB 2755
wsrep_sst_backup File 2.39 KB 0755
wsrep_sst_common File 67.46 KB 0644
wsrep_sst_mariabackup File 49.27 KB 0755
wsrep_sst_mysqldump File 8.1 KB 0755
wsrep_sst_rsync File 29.92 KB 0755
wsrep_sst_rsync_wan File 29.92 KB 0755
x86_64 File 20.76 KB 0755
x86_64-redhat-linux-c++ File 1.21 MB 0755
x86_64-redhat-linux-g++ File 1.21 MB 0755
x86_64-redhat-linux-gcc File 1.21 MB 0755
x86_64-redhat-linux-gcc-8 File 1.21 MB 0755
x86_64-redhat-linux-gnu-pkg-config File 424 B 0755
x86_energy_perf_policy File 31.95 KB 0755
xargs File 74.11 KB 0755
xgamma File 17.08 KB 0755
xgettext File 283.88 KB 0755
xhost File 17.12 KB 0755
xinput File 63.61 KB 0755
xkill File 17.1 KB 0755
xml2-config File 1.71 KB 0755
xmlcatalog File 20.38 KB 0755
xmllint File 73.37 KB 0755
xmlwf File 36.97 KB 0755
xmodmap File 39.98 KB 0755
xorg-x11-fonts-update-dirs File 1.29 KB 0744
xrandr File 65.46 KB 0755
xrdb File 33.98 KB 0755
xrefresh File 17.94 KB 0755
xset File 37.2 KB 0755
xsetpointer File 13.05 KB 0755
xsetroot File 21.44 KB 0755
xslt-config File 2.36 KB 0755
xsltproc File 28.47 KB 0755
xstdcmap File 17.68 KB 0755
xsubpp File 4.96 KB 0755
xz File 82.09 KB 0755
xzcat File 82.09 KB 0755
xzcmp File 6.48 KB 0755
xzdec File 16.48 KB 0755
xzdiff File 6.48 KB 0755
xzegrep File 5.76 KB 0755
xzfgrep File 5.76 KB 0755
xzgrep File 5.76 KB 0755
xzless File 1.76 KB 0755
xzmore File 2.11 KB 0755
yat2m File 33.34 KB 0755
yes File 33.37 KB 0755
ypdomainname File 21.16 KB 0755
yum File 2.05 KB 0755
yum-builddep File 3.62 KB 0755
yum-config-manager File 3.62 KB 0755
yum-debug-dump File 3.62 KB 0755
yum-debug-restore File 3.62 KB 0755
yum-groups-manager File 3.62 KB 0755
yumdownloader File 3.62 KB 0755
zcat File 1.94 KB 0755
zcmp File 1.64 KB 0755
zdiff File 5.74 KB 0755
zegrep File 29 B 0755
zfgrep File 29 B 0755
zforce File 2.03 KB 0755
zgrep File 7.4 KB 0755
zip File 229 KB 0755
zipcloak File 102.91 KB 0755
zipdetails File 49.39 KB 0755
zipgrep File 2.88 KB 0755
zipinfo File 201.88 KB 0755
zipnote File 97.76 KB 0755
zipsplit File 97.76 KB 0755
zless File 2.15 KB 0755
zmore File 1.8 KB 0755
znew File 4.45 KB 0755
zone2json File 1.39 MB 0755
zone2sql File 1.41 MB 0755
zsoelim File 42.55 KB 0755